
parse("bot_freeze 1")

if map("name") ~= "ow_cs2d_oasis" then
    parse("sv_map ow_cs2d_oasis")
    return
end

--hooks
addhook("startround_prespawn", "_startround_prespawn")
addhook("startround", "_startround")
addhook("say", "_say")
addhook("second", "_second")
addhook("serveraction", "_serveraction") 
addhook("menu", "_menu")
addhook("spawn", "_spawn")
addhook("always", "_always")
addhook("attack", "_attack")
addhook("movetile", "_movetile")
addhook("die", "_die")
addhook("leave", "_leave")
addhook("drop", "_drop")
addhook("team", "_team")
addhook("hit", "_hit")
addhook("select", "_select")
addhook("use", "_use")
addhook("walkover", "_walkover")

--static settings
parse("mp_deathdrop 4")
parse("mp_infammo 1")
parse("sv_name Overwatch")
parse("sv_fow 0")
parse("sv_maxplayers 24")
parse("mp_idleaction 4")
parse("mp_hud 75")
parse("mp_antispeeder 0")
parse("mp_autogamemode 0")
parse("mp_autoteambalance 0")
parse("mp_kickpercent 0")
parse("mp_mapvoteratio 0")
parse("mp_pinglimit 0")
parse("sv_checkusgnlogin 0")
parse("sv_friendlyfire 0")
parse("sv_gamemode 2")
parse("mp_trace 0")
parse("bot_prefix \"\"")
parse("mp_killteambuildings 1")
parse("mp_dispenser_money 0")
parse("mp_dispenser_health 10")
parse("sv_maptransfer 1")

--buildings
parse("mp_building_limit \"Barricade\" 0")
parse("mp_building_limit \"Barbed Wire\" 4")
parse("mp_building_limit \"Wall I\" 5")
parse("mp_building_limit \"Wall II\" 5")
parse("mp_building_limit \"Wall III\" 10")
parse("mp_building_limit \"Gate Field\" 5")
parse("mp_building_limit \"Dispenser\" 0")
parse("mp_building_limit \"Turret\" 20")
parse("mp_building_limit \"Supply\" 0")
parse("mp_building_limit \"Teleporter Entrance\" 0")
parse("mp_building_limit \"Teleporter Exit\" 0")
--prices
parse("mp_building_price \"Barricade\" 0")
parse("mp_building_price \"Barbed Wire\" 0")
parse("mp_building_price \"Wall I\" 0")
parse("mp_building_price \"Wall II\" 0")
parse("mp_building_price \"Wall III\" 0")
parse("mp_building_price \"Gate Field\" 0")
parse("mp_building_price \"Dispenser\" 0")
parse("mp_building_price \"Turret\" 0")
parse("mp_building_price \"Supply\" 0")
parse("mp_building_price \"Teleporter Entrance\" 0")
parse("mp_building_price \"Teleporter Exit\" 0")
parse("mp_dmspawnmoney 16000")
parse("mp_buymenu \"|||||\"")

--damages
parse("mp_wpndmg Laser 0")
parse("mp_wpndmg Chainsaw 0")

--taken from http://www.unrealsoftware.de/files_show.php?file=9699 credits Banaan (http://www.unrealsoftware.de/profile.php?userid=7130)
__ADDED_TIMERS__ = {}
local _timer = timer
local _freetimer = freetimer

function timer(time, func, p, c)
	
	if type(func) == "function" then func = func
	else
		error("timer: " .. tostring(func) .. " is not a valid function (type " .. type(func))
		return
	end
    
	local k = (tostring(func) .. tostring(p)):gsub("[^a-zA-Z0-9_]*", "_")
	__ADDED_TIMERS__[k] = { func = func, p = p }
	
	_timer(time, "__ADDED_TIMERS__." .. k .. ".func", p, c)
end


function freetimer(func, p)

	if type(func) == "function" then func = func
	else
		error("timer: " .. tostring(func) .. " is not a valid function (type " .. type(func))
		return
	end
	
	for k, v in pairs(__ADDED_TIMERS__) do
		if v.func == func and v.p == p then
			_freetimer("__ADDED_TIMERS__." .. k .. ".func", v.p)
			break
		end
	end
end

-- Used to keep track and display objective score
local overlay_bg, colon

local t_overlay = false
local ct_overlay = false
local contest_overlay = false

local red_count  = 0
local blue_count = 0

local red_numbers = {}
local blue_numbers = {}

local idToHero = {{}, {}}
local heroToId = {{}, {}}
local playerInfo = {}
for i = 1, 32 do
    playerInfo[i] = {}
end

function stripAll(id)
    parse("setarmor "..id.." 0")
    for _, wpn in pairs(playerweapons(id)) do
        if wpn ~= 50 then
            parse("strip "..id.." "..wpn)
        end
    end
end

local heros = {
    {
        name = "D.Va",
        caption = "Fusion Cannons",
        weapons = {85},
        armor = 202,
        speed = 10,
        knife = false,
        init = function(id)
            local info = playerInfo[id]
            local team = player(id, "team")
            local team_name = team == 1 and "t" or "ct"
        
            info.flip = true
    
            info.bot_1 = findNextId()
            parse("bot_add_"..team_name)
            
            info.bot_2 = findNextId(info.bot_1)
            parse("bot_add_"..team_name)
            
            parse("spawnplayer "..info.bot_1)
            parse("spawnplayer "..info.bot_2)
            
            parse("equip "..info.bot_1.." 90")
            parse("equip  "..info.bot_2.." 90")
            
            parse("setweapon "..info.bot_1.." 90")
            parse("setweapon "..info.bot_2.." 90")
            
            info.img = image("gfx/ow/dva.png", 1, 1, 132 + id)
        end,
        
        spawn = function(id)
            local info = playerInfo[id]
            
            parse("spawnplayer "..info.bot_1)
            parse("spawnplayer "..info.bot_2)
            
            parse("equip "..info.bot_1.." 90")
            parse("equip  "..info.bot_2.." 90")
            
            parse("setweapon "..info.bot_1.." 90")
            parse("setweapon "..info.bot_2.." 90")
        end,
        
        attack = function(id)
            local info = playerInfo[id]
        
            info.flip = not info.flip
            
            if info.flip then
                ai_attack(info.bot_1)
                parse("equip "..info.bot_1.." 90")
            else
                ai_attack(info.bot_2)
                parse("equip "..info.bot_2.." 90")
            end
        
        end,
        
        death = function(id)
            local info = playerInfo[id]
            
            parse("killplayer "..info.bot_1)
            parse("killplayer "..info.bot_2)
        end,
        
        destroy = function(id)
            local info = playerInfo[id]
            
            freeimage(info.img)
            
            parse("kick "..info.bot_1)
            parse("kick "..info.bot_2)
        end
    
    },
    {
        name = "Mercy",
        caption = "Caduceus Staff",
        weapons = {45, 2},
        armor = 204,
        speed = 5,
        knife = false,
        init = function(id)
            local info = playerInfo[id]
            
            info.img = image("gfx/ow/mercy.png", 2, 1, 132 + id)
        end,
        
        destroy = function(id)
            local info = playerInfo[id]
            
            freeimage(info.img)
        end
    }, {
        name = "Pharah",
        caption = "Rocket Launcher",
        weapons = {48},
        knife = false,
        speed = 10,
        init = function(id)
            local info = playerInfo[id]
            
            info.img = image("<spritesheet:gfx/ow/pharah.png:128:143>", 1, 1, 132 + id)
        end,
        attack = function(id)
            local info = playerInfo[id]
            
            imageframe(info.img, 2)
            
            timer(500, function()
                imageframe(info.img, 1)
            end)
        
        end,
        
        destroy = function(id)
            local info = playerInfo[id]
            
            freeimage(info.img)
        end
            
    
    
    }, {
        name = "Widowmaker",
        caption = "Sniper Rifle",
        weapons = {35},
        knife = true,
        speed = 5,
        init = function(id)
            local info = playerInfo[id]
            
            info.img = image("gfx/ow/widow.png", 2, 1, 200 + id)
        end,
        
        destroy = function(id)
            local info = playerInfo[id]
            
            freeimage(info.img)
        end
    }, {
        name = "Soldier 76",
        caption = "Heavy Pulse Rifle",
        weapons = {32},
        knife = true,
        speed = 5
    }, {
        name = "Junkrat",
        caption = "Frag Launcher",
        weapons = {49, 89, 77},
        knife = true,
        speed = 5
    }, {
        name = "Torbjorn",
        caption = "Wrench",
        weapons = {74},
        knife = false
    }, {
        name = "McCree",
        caption = "Peacekeeper",
        weapons = {3, 52},
        knife = true
    }, {
        name = "Reaper",
        caption = "Hellfire Shotguns",
        weapons = {11},
        knife = true
    }
}

function resetID(id)
    local team = player(id, "team")
    if team == 0 then
        return
    end
    
    local hero = idToHero[team][id]
    
    if hero ~= nil then
    
        if heros[hero].destroy then
            heros[hero].destroy(id)
        end
        
        idToHero[team][id] = nil
        heroToId[team][hero] = nil
    end
end

function findNextId(id)
    for i = 1, 32 do
        if i ~= id and not player(i, "exists") then
            return i
        end
    end
    
    return -1
end

function setpos(id, x, y)
    parse("setpos "..id.." "..x.." "..y)
end

function _select(id, _type, mode)
    local team = player(id, "team")
    if team == 0 then
        return
    end
    
    local hero = idToHero[team][id]
    if hero == nil then
        return
    end
    
    if _type == 50 and hero and not heros[hero].knife then
        parse("setweapon "..id.." "..heros[hero].weapons[1])
    end
end

function _drop(id, weapon)
    return 1
end

function _walkover(id, wpnID, _type, ain, a, mode)
    return 1
end

function _use(id)
    local team = player(id, "team")
    if team == 0 then
        return
    end
    
    local hero = idToHero[team][id]
    
    if hero == nil then
        return
    end
    
    
    
    if heros[hero].name == "Soldier 76" then
        local info = playerInfo[id]
        
        local c_time = os.time()
        
        if info.dispenser and info.dispenser + 9 >= c_time then
            local dispenser = info.dispenser + 9 - c_time + 1
            local s = "s"
            if dispenser == 1 then
                s = ""
            end
            msg2(id, "\169255000000Wait "..dispenser.." second"..s.." before placing another dispenser.")
            return
        end
    
        info.dispenser = c_time
    
    
        local x, y = player(id, "tilex"), player(id, "tiley")
        
        parse("spawnobject 7 "..x.." "..y.." 0 0 "..player(id, "team").." "..id)
        timer(5000, function()
            local obj = objectat(x, y, 7)
            if obj ~= 0 then
                parse("killobject "..obj)
            end
        end)
    end
end

function _die(id, killer, wpn, x, y, kID)
    if player(id, "bot") then
        return
    end
    
    local hero = idToHero[player(id, "team")][id]
    if hero == nil then
        return
    end
    
    if heros[hero].death then
        heros[hero].death(id)
    end
end

function _movetile(id, tilex, tiley)
    local team = player(id, "team")
    
    if team == 0 or player(id, "bot") then
        return
    end
    
    if (team == 1 and tiley <= 37) or (team == 2 and tiley >= 89) then
        parse("killplayer "..id)
    end
end

function _team(id, team, look)
    local t = player(id, "team")
    
    if t == 0 then
        return 0
    end
    
    
    resetID(id)

    return 0
end

function _attack(id)
    if player(id, "bot") then
        return
    end
    
    local hero = idToHero[player(id, "team")][id]
    if hero == nil then
        return
    end
    
    if heros[hero].attack ~= nil then
        heros[hero].attack(id)
    end
end

function _hit(id, source, weapon, hpdmg)
    if player(id, "bot") then
        return 1
    end
    
    local info = playerInfo[id]

    if weapon == 45 and source ~= 0 and player(id, "team") == player(source, "team") then
        parse("sethealth "..id.." "..(player(id, "health") + 20))
        msg2(id, "\169000255000Healed by "..player(source, "name").." (+20 HP)@C")
        
        if player(id, "health") >= player(id, "maxhealth") and info.critical then
            freeimage(info.critical)
            info.critical = nil
            return 0
        end
    end
    
    local healer = heroToId[player(id, "team")][2]
    
    if healer and id ~= healer and hpdmg > 0 then
        if not info.critical then
            info.critical = image("gfx/ow/critical.png", 0, 1, 132 + id, healer)
        end
    end
    
    return 0
end

function animateDva(dva)
    if dva == nil then
        return
    end
    
    local angle = math.rad(player(dva, "rot"))
    local angle2 = math.rad(player(dva, "rot") - 180)
    
    local x, y = player(dva, "x"), player(dva, "y")
    local info = playerInfo[dva]
    
    local bot_1, bot_2 = info.bot_1, info.bot_2
    
    setpos(bot_1,
        x + math.cos(angle) * 28,
        y + math.sin(angle) * 28)
        
    setpos(bot_2,
        x + math.cos(angle2) * 28,
        y + math.sin(angle2) * 28)
       
    ai_rotate(bot_1, player(dva, "rot") - 10)
    ai_rotate(bot_2, player(dva, "rot") + 10)
end

function _always()
    animateDva(heroToId[1][1])
    animateDva(heroToId[2][1])
end

function table.contains(_table, _element)
    for _, value in pairs(_table) do
        if value == _element then
            return true
        end
    end
    return false
end

function initWpns(def, id)
    if def == nil then
        return
    end
    
    local armor = def.armor or 0
    
    parse("setarmor "..id.." "..armor)
    
    if def.weapons then
        for _, wpn in ipairs(def.weapons) do
            parse("equip "..id.." "..wpn)
        end
    end
    
    for _, wpn in ipairs(playerweapons(id)) do
        if not table.contains(def.weapons, wpn) and wpn ~= 50 then
            parse("strip "..id.." "..wpn)
        end
    end
    
    parse("setweapon "..id.." "..def.weapons[1])
    
    if def.speed then
        parse("speedmod "..id.." "..def.speed)
    end
end

function _spawn(id)
    if player(id, "bot") then
        return "x"
    end
    
    local team = player(id, "team")
    
    local t_count = 0
    for _, t in ipairs(player(0, "team1")) do
        if not player(t, "bot") then
            t_count = t_count + 1
        end
    end
    
    local ct_count = 0
    for _, ct in ipairs(player(0, "team2")) do
        if not player(ct, "bot") then
            ct_count = ct_count + 1
        end
    end
    
    if ct_count - t_count > 1 and team == 2 then
        parse("maket "..id)
        
        msg2(id, "\169255000000Auto-teambalance@C")
        return "x"
    elseif t_count - ct_count > 1 and team == 1 then
        parse("makect "..id)
        
        msg2(id, "\169255000000Auto-teambalance@C")
        return "x"
    end

    local hero = idToHero[player(id, "team")][id]
    
    if hero == nil then
        parse("speedmod "..id.." 0")
        msg2(id, "\169255255000Press \169000255000F2 \169255255000to select a hero@C")
        return "x"
    end
    
    local def = heros[hero]
    local info = playerInfo[id]
    
    if info.critical then
        freeimage(info.critical)
        info.critical = nil
    end
    
    timer(1, function() initWpns(def, id) end)
    
    if def.spawn then
        timer(2, function() def.spawn(id) end)
    end
    
    return "x"
end

function canChangeHero(id)
    local tiley = player(id, "tiley")
    local team  = player(id, "team")
    
    if (player(id, "health") > 0) and ((team == 1 and tiley >= 89) or (team == 2 and tiley <= 37)) then
        return true
    end
    
    msg2(id, "\169255000000You need to be in the spawn room to change heros!@C")
    return false
end

function _menu(id, title, button)
    if title ~= "Select your hero" or button == 0 or not canChangeHero(id) then
        return
    end
    
    local team = player(id, "team")
    local hero = idToHero[team][id]
    local info = playerInfo[id]
    
    if heroToId[team][button] ~= nil then
        msg2(id, "\169255000000That hero has already been selected!@C")
        showHeroMenu(id)
        return
    end
    
    local c_time = os.time()
    
    
    if info.timeout and info.timeout + 4 >= c_time then
        local timeout = info.timeout + 4 - c_time + 1
        local s = "s"
        if timeout == 1 then
            s = ""
        end
        msg2(id, "\169255000000Please wait "..timeout.." second"..s.." before switching heros.@C")
        return
    end
    
    info.timeout = c_time
    
    local previous = nil
    
    if hero ~= nil then
    
        if heros[hero].destroy then
            heros[hero].destroy(id)
        end
        
        previous = hero
        heroToId[team][hero] = nil
    end
    
    local color = "255000000"
    if player(id, "team") == 2 then
        color = "000000255"
    end
    
    if previous then
        msg("\169"..color..player(id, "name").." \169255165000switched to "..heros[button].name.." (\169"..color.."was "..heros[previous].name.."\169255165000)")
    end
    
    
    heroToId[team][button] = id
    idToHero[team][id] = button
    hero = button
    
    local def = heros[hero]
    
    initWpns(def, id)
    
    if def.init then
        def.init(id)
    end
end

function showHeroMenu(id)
    if not canChangeHero(id) then
        return
    end
    
    local txt = ""
    
    for i = 1, 9 do
        local full = heros[i].name.."|"..heros[i].caption
        if heroToId[player(id, "team")][i] == nil then
            txt = txt .. full
        else
            txt = txt .. "(" .. full .. ")"
        end
        
        if i ~= 9 then
            txt = txt .. ","
        end
    end
    
    menu(id, "Select your hero,"..txt)
end

function _serveraction(id, action)
    if action ~= 1 or not canChangeHero(id) then
        return
    end
    
    showHeroMenu(id)
end

function showContested()
    imagecolor(overlay_bg, 255, 255, 0)
    parse("hudtxt 0 \"\169255255255*CONTESTED*\" 320 402 1")
end

function showBlue()
    imagecolor(overlay_bg, 0, 0, 255)
    parse("hudtxt 0 \"\169000000255*BLUE TEAM*\" 320 402 1")
end

function showRed()
    imagecolor(overlay_bg, 255, 0, 0)
    parse("hudtxt 0 \"\169255000000*RED TEAM*\" 320 402 1")
end

function hideContested()
    imagecolor(overlay_bg, 255, 255, 255)
    parse("hudtxt 0 \"\169000255000100 TO WIN\" 320 402 1")
end

function setNumbers(images, number)
    if number < 10 then
        imageframe(images[1], 1)
        imageframe(images[2], number + 1)
    else
        imageframe(images[1], tonumber(string.sub(number, 1, 1)) + 1)
        imageframe(images[2], tonumber(string.sub(number, 2, 2)) + 1)
    end
end  

function inBox(x, y)
    return x >= 49 and x <= 57 and y >= 58 and y <= 68
end

function setOverlay(num)
    if num == 1 then
        if not t_overlay then
            t_overlay = true
            parse("trigger t_overlay")
        end
        
        if ct_overlay then
            ct_overlay = false
            parse("trigger ct_overlay")
        end
        
        if contest_overlay then
            contest_overlay = false
            parse("trigger contest_overlay")
        end
    elseif num == 2 then
        if t_overlay then
            t_overlay = false
            parse("trigger t_overlay")
        end
        
        if not ct_overlay then
            ct_overlay = true
            parse("trigger ct_overlay")
        end
        
        if contest_overlay then
            contest_overlay = false
            parse("trigger contest_overlay")
        end
    elseif num == 3 then
        if t_overlay then
            t_overlay = false
            parse("trigger t_overlay")
        end
        
        if ct_overlay then
            ct_overlay = false
            parse("trigger ct_overlay")
        end
        
        if not contest_overlay then
            contest_overlay = true
            parse("trigger contest_overlay")
        end
    elseif num == 4 then
        if t_overlay then
            t_overlay = false
            parse("trigger t_overlay")
        end
        
        if ct_overlay then
            ct_overlay = false
            parse("trigger ct_overlay")
        end
        
        if contest_overlay then
            contest_overlay = false
            parse("trigger contest_overlay")
        end
    end
end

function _second()
    local red  = false
    local blue = false
    
    if red_count == 100 or blue_count == 100 then
        return
    end

    for _, id in ipairs(player(0,"team1living")) do
        if inBox(player(id, "tilex"), player(id, "tiley")) then
            red = true
            break
        end
    end
    
    for _, id in ipairs(player(0,"team2living")) do
        if inBox(player(id, "tilex"), player(id, "tiley")) then
            blue = true
            break
        end
    end
    
    if red and blue then
        showContested()
        setOverlay(3)
        return
    else
        hideContested()
        setOverlay(4)
    end
    
    if red then
        showRed()
        setOverlay(1)
        
        red_count = red_count + 1
        if red_count == 100 then
            parse("trigger t_win")
            
            return
        end
        
        setNumbers(red_numbers, red_count)
        
        
    elseif blue then
        showBlue()
        setOverlay(2)
        
        blue_count = blue_count + 1
        
        if blue_count == 100 then
            parse("trigger ct_win")
            
            return
        end
        
        setNumbers(blue_numbers, blue_count)
    end
    
end

function _startround_prespawn()
    parse("bot_remove_all")

    idToHero = {{}, {}}
    heroToId = {{}, {}}
    playerInfo = {}
    for i = 1, 32 do
        playerInfo[i] = {}
    end 
    
end

function _leave(id, reason)
    resetID(id)
end

function _startround()
    for _, id in ipairs(player(0,"tableliving")) do
        stripAll(id)
    end
    
    t_overlay = false
    ct_overlay = false
    contest_overlay = false
    
    overlay_bg = image("gfx/ow/overlay.png", 320, 432, 2)
    
    red_numbers = {
        image("<spritesheet:gfx/ow/numbers.png:20:35>", 280, 440, 2),
        image("<spritesheet:gfx/ow/numbers.png:20:35>", 300, 440, 2)
    }
    
    imagecolor(red_numbers[1], 255, 0, 0)
    imagecolor(red_numbers[2], 255, 0, 0)
    
    
    colon = image("<spritesheet:gfx/ow/numbers.png:20:35>", 320, 440, 2)
    imageframe(colon, 11)
    
    blue_numbers = {
        image("<spritesheet:gfx/ow/numbers.png:20:35>", 340, 440, 2),
        image("<spritesheet:gfx/ow/numbers.png:20:35>", 360, 440, 2)
    }
    red_count = 0
    blue_count = 0
    
    imagecolor(blue_numbers[1], 0, 0, 255)
    imagecolor(blue_numbers[2], 0, 0, 255)
end

_startround()



